-----------------------------------------------------------------
--Compressor, by Justin Snyder, 13-------------------------------
-----------------------------------------------------------------
--It looks at a binary phrase and finds appearances of zeros,----
--Then it turns that pattern into bytes.-------------------------
--This algorithm compressed a 71 kb bitmap into a 12 kb file-----
--decompressing can be buggy with files--------------------------
-----------------------------------------------------------------
--It currently won't do data with too much of spaces and such,---
--I think you can't do more than 32 zero values consectutively.--
-----------------------------------------------------------------
--THIS IS THE INCOMPLETE VERSION, I WILL MAKE IMPROVEMENTS-------
-----------------------------------------------------------------
include machine.e
include sort.e
include hex.e
with trace

function zero_pattern(sequence bits)
    integer counter
    sequence pattern
    counter = 0
    pattern = {}
    for i=1 to length(bits) do
        if bits[i] = 0 then
            counter += 1
        else
            pattern &= counter+1
            counter = 0
        end if
    end for
    return pattern
end function

function bit_pattern(sequence zero)
    integer counter, rem
    sequence bits
    counter = 0
    bits = {}
    for i=1 to length(zero) do
        if zero[i]-1 = 0 then
            --do nothing
        else
            counter = zero[i]
            for ii=1 to zero[i]-1 do
                bits &= 0
            end for
        end if
        bits &= 1
    end for
    rem = remainder(length(bits),8)
    if rem then
        bits &= repeat(0,(8-rem))
    end if
    return bits
end function

function zero_to_bytes(sequence zero)
    atom large, loop, rem, len
    integer hex1, hex2
    sequence bytes, temp, bits
    bytes = {}
    bits = {}
    temp = sort(zero)
    large = temp[length(zero)]
    if large < 256 and large >= 128 then
        hex1 = 8
    elsif large < 128 and large >= 64 then
        hex1 = 7
    elsif large < 64 and large >= 32 then
        hex1 = 6
    elsif large < 32 and large >= 16 then
        hex1 = 5
    elsif large < 16 and large >= 8 then
        hex1 = 4
    elsif large < 8 and large >= 4 then
        hex1 = 3
    elsif large < 4 and large >= 2 then
        hex1 = 2
    elsif large < 2 and large >= 1 then
        hex1 = 1
    else
        return 0
    end if
    for i=1 to length(zero) do
        bits &= int_to_bits(zero[i],hex1)
    end for
    len = length(bits)
    rem = remainder(len,8)
    loop = 1
    hex2 = rem
    bytes &= combine_hex(hex1, hex2)
    while loop < len - 7 do
        bytes &= bits_to_int(bits[loop..loop+7])
        loop += 8
    end while
    bytes &= bits_to_int(bits[length(bits)-(rem-1)..length(bits)]& repeat(0, 8-rem)) 
    return bytes
end function

function bytes_to_zero(sequence bytes)
    atom check, rem
    sequence zero, bits, step, hex
--	trace(1)
    zero = {}
    bits = {}
    hex = separate_hex(bytes[1])
    check = hex[1]
    if check then
        rem = hex[2]
        for i=2 to length(bytes) do
            bits &= int_to_bits(bytes[i],8)
        end for
        step = bits[1..length(bits)-(8-rem)]
        for ii=1 to length(step) by check do
            zero &= bits_to_int(step[ii..(ii+(check-1))])
        end for
    else    
    end if
    return zero
end function

function compress(sequence data)
    sequence first, second
    object third
    first = {}
    for i=1 to length(data) do
        first &= int_to_bits(data[i], 8)
    end for
    second = zero_pattern(first)
    third = zero_to_bytes(second)
    if atom(third) then
        return 0 & data
    end if
    return 1 & third
end function

function decompress(sequence data)
    sequence third, second, first, slice
    atom check
    first = {}
    check = data[1]
    slice = data[2..length(data)]
    if check = 0 then
        return slice
    end if
    third = bytes_to_zero(slice)
    second = bit_pattern(third)
    for i=1 to length(second) by 8 do
        first &= bits_to_int(second[i..i+7])
    end for
    return first
end function

global procedure compress_to_file(sequence data, sequence dest)
    atom cfile
    sequence comp
    comp = compress(data)
    cfile = open(dest, "w")
    puts(cfile, comp)
end procedure

global function decompress_from_file(sequence source)
    atom dfile
    sequence dcomp
    dfile = open(source, "rb")
    dcomp = decompress(gets(dfile))
    return dcomp
end function

global procedure compress_file(sequence source, sequence dest)
    atom afile
    sequence acomp
    afile = open(source, "rb")
    acomp = gets(afile)
    compress_to_file(acomp, dest)
end procedure

global procedure decompress_file(sequence source, sequence dest)
    atom afile
    sequence adcomp
    adcomp = decompress_from_file(source)
    afile = open(dest, "w")
    puts(afile, adcomp)
end procedure



--TEST
--atom file
--sequence compressed, text
--file = open("test.txt","w")
--bytes = bytes_to_zero(test)
--puts(file,"Hello World!\n")
--compressed = compress("Hello World!")
--puts(file,compressed & '\n')
--text = decompress(compressed)
--puts(file,text)
--close(file)

--TEST2
compress_file("test.bmp","test.sav")
--decompress_file("test.sav","test2.bmp")

