include machine.e
--with trace


global function combine_hex(integer h1, integer h2)
    integer ret
    sequence bits
--	trace(1)
    ret = 0
    bits = {}
    if h1 < #10 and h2 < #10 then
        bits &= int_to_bits(h1, 4)
        bits &= int_to_bits(h2, 4)
        ret = bits_to_int(bits)
    end if
--	trace(0)
    return ret
end function

global function separate_hex(integer byte)
    sequence ret, bits
    trace(1)
    ret = {}
    if byte < 256 then
        bits = int_to_bits(byte, 8)
        ret &= bits_to_int(bits[1..4])
        ret &= bits_to_int(bits[5..8])
    end if
    trace(0)
    return ret
end function